/*
 * ContentRetriever.java
 *
 * Created on February 28, 2002, 6:44 AM
 */
import java.net.*;
import java.io.*;
/**
 * This is a singleton class to retrieve content from url's
 *
 * @author  andrewm
 * @version
 */
public class ContentRetriever
{
    // ContentRetriever instance
    private static ContentRetriever retriever;
    
    /**
     * Static method which returns the instance of the ContentRetriever
     *
     * @return ContentRetriever An instance of the ContentRetriever
     */
    public static ContentRetriever getInstance()
    {
	// If the retriever is null ( this is the first time the getInstance has been called )
	if ( retriever == null )
	{
	    // Create a new instance
	    retriever = new ContentRetriever();
	}
	
	// Return the instance
	return retriever;
    }
    
    /**
     * retrieveContent - retrieves the content from the specified url
     *
     * @param _url url of the content to be retrieved
     * @return InputStream InputStream that is retrieved after connecting to the url
     */
    public InputStream retrieveContent( String _url )
    {
	// URLConnection object
	URLConnection connection;
	
	// InputStream
	InputStream input = null;
	
	try
	{
	    // Create the connection to the specified url
	    connection = new URL( _url ).openConnection();
	    
	    // Connect to the url
	    connection.connect();
	    
	    // Retrieve the InputStream
	    input = connection.getInputStream();
	}
	catch( Throwable t )
	{
	    t.printStackTrace();
	}
	finally
	{
	    // Return the InputStream
	    return input;
	}
    }
}
